pms/urls.py
from django.contrib import admin
from django.urls import path
from django.contrib import admin
from django.conf import settings as SETTINGS
from django.conf.urls.static import static
from django.urls import include, re_path
from core import views as core_views



urlpatterns = [
    re_path(r'^admin/', admin.site.urls),
    re_path(r'^app/accounts/', include('registration.backends.default.urls')),

    re_path(r'^$', core_views.App.as_view(), name='app'),
    re_path(r'^app/$', core_views.App.as_view(), name='app'),
    re_path(r'^app/dashboard/$', core_views.DashboardView.as_view(), name='dashboard'),

    re_path(r'^app/properties/', include('properties.urls')),
    re_path(r'^app/tenants/', include('tenants.urls')),





] + static(SETTINGS.STATIC_URL, document_root=SETTINGS.STATIC_ROOT) + static(SETTINGS.MEDIA_URL, document_root=SETTINGS.MEDIA_ROOT)

handler404 = 'core.views.page_not_found'
handler500 = 'core.views.error'
handler403 = 'core.views.permission_denied'
handler400 = 'core.views.bad_request'

tenants/urls.py
from django.urls import re_path
from tenants import views

app_name = 'tenants'

urlpatterns = [
    # DocumentType year URLs
    re_path(r'^document-type/create/$', views.DocumentTypeCreateView.as_view(), name='document_type_create'),
    re_path(r'^document-type/view/(?P<pk>[0-9a-f-]+)/$', views.DocumentTypeDetailView.as_view(), name='document_type_view'),
    re_path(r'^document-type/list/$', views.DocumentTypeListView.as_view(), name='document_type_list'),
    re_path(r'^document-type/update/(?P<pk>[0-9a-f-]+)/$', views.DocumentTypeUpdateView.as_view(), name='document_type_update'),
    re_path(r'^document-type/delete/(?P<pk>[0-9a-f-]+)/$', views.DocumentTypeDeleteView.as_view(), name='document_type_delete'),
    # Tenant year URLs
    re_path(r'^tenant/create/$', views.TenantCreateView.as_view(), name='tenant_create'),
    re_path(r'^tenant/view/(?P<pk>[0-9a-f-]+)/$', views.TenantDetailView.as_view(), name='tenant_view'),
    re_path(r'^tenant/list/$', views.TenantListView.as_view(), name='tenant_list'),
    re_path(r'^tenant/update/(?P<pk>[0-9a-f-]+)/$', views.TenantUpdateView.as_view(), name='tenant_update'),
    re_path(r'^tenant/delete/(?P<pk>[0-9a-f-]+)/$', views.TenantDeleteView.as_view(), name='tenant_delete'),

    # Tenant year URLs
    re_path(r'^assign-tenant-unit/create/$', views.TenantUnitAssignCreateView.as_view(), name='tenant_unit_assign_create'),
    re_path(r'^assign-tenant-unit/list/$', views.TenantUnitAssignListView.as_view(), name='tenant_unit_assign_list'),
    re_path(r'^assign-tenant-unit/update/(?P<pk>[0-9a-f-]+)/$', views.TenantUnitAssignUpdateView.as_view(), name='tenant_unit_assign_update'),
    re_path(r'^assign-tenant-unit/delete/(?P<pk>[0-9a-f-]+)/$', views.TenantUnitAssignDeleteView.as_view(), name='tenant_unit_assign_delete'),
]

tenants/models.py
from django.core.exceptions import ValidationError
from django.db import models

from core.models import BaseModel
from django.utils.translation import gettext_lazy as _
from django.core.validators import MinValueValidator
from decimal import Decimal
from django.core.validators import RegexValidator

PhoneRegexValidator = RegexValidator(r"^((\+91|91|0)[\- ]{0,1})?[456789]\d{9}$",
                                     message="Please Enter 10 digit mobile number or landline as 0<std code><phone number>", code="invalid_mobile")


class DocumentType(BaseModel):
    name = models.CharField(max_length=256)

    class Meta:
        verbose_name = _('Feature')
        verbose_name_plural = _('Features')

    def __str__(self):
        return self.name


class Tenant(BaseModel):
    name = models.CharField(max_length=256)
    address = models.TextField(null=True, blank=True)
    phone = models.CharField(max_length=14, null=True, blank=True, validators=[PhoneRegexValidator])
    email = models.EmailField(null=True, blank=True)

    class Meta:
        verbose_name = _('Tenant')
        verbose_name_plural = _('Tenant')
        ordering = ('name',)

    def __str__(self):
        return self.name


class TenantDocument(models.Model):

    document_type = models.ForeignKey(DocumentType, on_delete=models.CASCADE, limit_choices_to={'is_deleted': False})
    tenant = models.ForeignKey(Tenant, on_delete=models.CASCADE, limit_choices_to={'is_deleted': False})
    file = models.FileField(upload_to='documents/%Y/%m/%d/')

    def __str__(self):
        return self.tenant.name


class TenantUnitAssign(BaseModel):
    tenant = models.ForeignKey(Tenant, on_delete=models.CASCADE, limit_choices_to={'is_deleted': False})
    unit = models.ForeignKey('properties.Unit', on_delete=models.CASCADE)
    agreement_end_date = models.DateField()
    upcoming_rent_date = models.DateField()  # TODO: Add a logic to calculate next month's rent date
    agreement = models.FileField(upload_to='documents/%Y/%m/%d/', blank=True, null=True)
    is_active = models.BooleanField(default=True)

    class Meta:
        verbose_name = _('TenantUnitAssign')
        verbose_name_plural = _('TenantUnitAssigns')

    def __str__(self):
        return self.tenant.name

    def clean(self):
        # Check if the tenant is already assigned to another unit
        if self.is_active and TenantUnitAssign.objects.filter(is_active=True, unit=self.unit).exclude(pk=self.pk).exists():
            raise ValidationError(_('This unit is already assigned to other tenant.'))

tenants/forms.py
from django import forms

from tenants.models import DocumentType, Tenant, TenantDocument, TenantUnitAssign


class DocumentTypeForm(forms.ModelForm):

    class Meta:
        model = DocumentType
        exclude = ['creator', 'updater', 'date_updated', 'auto_id', 'is_deleted']

        widgets = {
            'name': forms.TextInput(attrs={'class': 'form-control', 'placeholder': 'Name'}),
        }


class TenantForm(forms.ModelForm):

    class Meta:
        model = Tenant
        exclude = ['creator', 'updater', 'date_updated', 'auto_id', 'is_deleted']

        widgets = {
            'name': forms.TextInput(attrs={'class': 'form-control', 'placeholder': 'Name'}),
            'address': forms.TextInput(attrs={'class': 'form-control', 'placeholder': 'Address'}),
            'phone': forms.TextInput(attrs={'class': 'form-control', 'placeholder': 'Phone'}),
            'email': forms.EmailInput(attrs={'class': 'form-control', 'placeholder': 'Email'}),
        }


class TenantDocumentForm(forms.ModelForm):

    class Meta:
        model = TenantDocument
        exclude = ['tenant']

        widgets = {
            'document_type': forms.Select(attrs={'class': 'required form-control', 'placeholder': 'TenantDocument Type'}),
        }


class TenantUnitAssignForm(forms.ModelForm):

    class Meta:
        model = TenantUnitAssign
        exclude = ['creator', 'updater', 'date_updated', 'auto_id', 'is_deleted']

        widgets = {
            'tenant': forms.Select(attrs={'class': 'required form-control', 'placeholder': 'TenantDocument Type'}),
            'unit': forms.Select(attrs={'class': 'required form-control', 'placeholder': 'TenantDocument Type'}),
            'agreement_end_date': forms.DateInput(attrs={'type': 'date', 'class': 'required form-control', 'placeholder': 'Agreement End Date'}),
            'upcoming_rent_date': forms.DateInput(attrs={'type': 'date', 'class': 'required form-control', 'placeholder': 'Agreement End Date'}),
        }

tenants/views.py
import json

from django.db.models import Q
from django.forms.formsets import formset_factory
from django.forms.models import inlineformset_factory
from django.http import HttpResponse
from django.shortcuts import render
from django.urls import reverse
from django.utils import timezone
from django.views.generic import DetailView, View
from django.views.generic.detail import SingleObjectMixin
from django_filters.views import FilterView

from core.functions import CPaginator, generate_form_errors, get_auto_id
from core.views import CheckSuperRolesMixin
from tenants.filters import DocumentTypeFilter, TenantFilter, TenantUnitAssignFilter
from tenants.forms import (
    DocumentTypeForm,
    TenantDocumentForm,
    TenantForm,
    TenantUnitAssignForm,
)
from tenants.models import DocumentType, Tenant, TenantDocument, TenantUnitAssign


class DocumentTypeCreateView(CheckSuperRolesMixin, View):
    def get(self, *args, **kwargs):
        form = DocumentTypeForm()

        context = {
            "form": form,
            "title": "Create DocumentType",
            "redirect": True,
            "active_menu": "document_type",
        }
        return render(self.request, "tenants/document_type/document_type_entry.html", context)

    def post(self, *args, **kwargs):

        form = DocumentTypeForm(self.request.POST)

        if form.is_valid():

            data = form.save(commit=False)
            data.auto_id = get_auto_id(DocumentType)
            data.creator = self.request.user
            data.date_added = timezone.now()
            data.save()

            response_data = {
                "status": "true",
                "title": "Successfully Created",
                "message": "DocumentType created successfully.",
                "redirect": "true",
                "redirect_url": reverse('tenants:document_type_list')
            }

        else:
            message = str(generate_form_errors(form, formset=False))

            response_data = {
                "status": "false",
                "title": "Form validation error",
                "message": message
            }

        return HttpResponse(json.dumps(response_data), content_type='application/javascript')


class DocumentTypeUpdateView(CheckSuperRolesMixin, SingleObjectMixin, View):
    model = DocumentType

    def post(self, *args, **kwargs):
        self.object = self.get_object()
        form = DocumentTypeForm(self.request.POST, instance=self.object)
        if form.is_valid():
            data = form.save(commit=False)
            data.updater = self.request.user
            data.date_updated = timezone.now()
            data.save()

            response_data = {
                "status": "true",
                "title": "Successfully Updated",
                "message": "DocumentType Successfully Updated.",
                "redirect": "true",
                "redirect_url": reverse('tenants:document_type_list')
            }
        else:
            message = generate_form_errors(form, formset=False)
            response_data = {
                "status": "false",
                "stable": "true",
                "title": "Form validation error",
                "message": message
            }

        return HttpResponse(json.dumps(response_data), content_type='application/javascript')

    def get(self, *args, **kwargs):
        self.object = self.get_object()
        form = DocumentTypeForm(instance=self.object)

        context = {
            "form": form,
            "title": "Edit DocumentType : " + self.object.__str__(),
            "instance": self.object,
            "redirect": True,
            "active_menu": "document_type",
            "is_edit_page": True,
        }
        return render(self.request, "tenants/document_type/document_type_entry.html", context)


class DocumentTypeListView(CheckSuperRolesMixin, FilterView):
    model = DocumentType
    paginate_by = 21
    paginator_class = CPaginator
    template_name = "tenants/document_type/document_type_list.html"
    context_object_name = "instances"
    filterset_class = DocumentTypeFilter

    def get_context_data(self, *args, **kwargs):
        context = super().get_context_data(*args, **kwargs)
        context["title"] = "DocumentType"
        context["active_menu"] = "document_type"

        return context


class DocumentTypeDetailView(CheckSuperRolesMixin, DetailView):
    model = DocumentType
    template_name = "tenants/document_type/document_type_view.html"
    context_object_name = "instance"

    def get_context_data(self, *args, **kwargs):
        context = super().get_context_data(*args, **kwargs)
        context["title"] = "DocumentType"
        context["active_menu"] = "document_type"
        context['instance_form_data'] = DocumentTypeForm(instance=self.get_object())

        return context


class DocumentTypeDeleteView(CheckSuperRolesMixin, SingleObjectMixin, View):
    model = DocumentType

    def get(self, *args, **kwargs):
        self.object = self.get_object()
        self.object.is_deleted = True
        self.object.save()

        response_data = {
            "status": "true",
            "title": "Successfully Deleted",
            "message": "DocumentType Successfully Deleted.",
            "redirect": "true",
            "redirect_url": reverse('tenants:document_type_list')
        }
        return HttpResponse(json.dumps(response_data), content_type='application/javascript')


class TenantCreateView(CheckSuperRolesMixin, View):
    TenantDocumentFormset = formset_factory(TenantDocumentForm, extra=1)

    def get(self, *args, **kwargs):
        tenant_document_formset = self.TenantDocumentFormset(prefix="tenant_document_formset")
        form = TenantForm()
        context = {
            "form": form,
            "title": "Create Tenant",
            "redirect": True,
            "active_menu": "tenant",
            'tenant_document_formset': tenant_document_formset
        }
        return render(self.request, "tenants/tenant/tenant_entry.html", context)

    def post(self, *args, **kwargs):

        form = TenantForm(self.request.POST)

        tenant_document_formset = self.TenantDocumentFormset(self.request.POST, self.request.FILES, prefix='tenant_document_formset', form_kwargs={'empty_permitted': False})

        if form.is_valid() and tenant_document_formset.is_valid():

            data = form.save(commit=False)
            data.auto_id = get_auto_id(Tenant)
            data.creator = self.request.user
            data.save()
            form.save_m2m()

            for item in tenant_document_formset:
                tenant_document_data = item.save(commit=False)
                tenant_document_data.tenant = data
                tenant_document_data.save()

            response_data = {
                "status": "true",
                "title": "Successfully Created",
                "message": "Tenant created successfully.",
                "redirect": "true",
                "redirect_url": reverse('tenants:tenant_list')
            }

        else:
            message = str(generate_form_errors(form, formset=False))
            message += str(generate_form_errors(tenant_document_formset, formset=True))

            response_data = {
                "status": "false",
                "title": "Form validation error",
                "message": message
            }

        return HttpResponse(json.dumps(response_data), content_type='application/javascript')


class TenantUpdateView(CheckSuperRolesMixin, SingleObjectMixin, View):
    model = Tenant

    def get_formset(self):
        instance = self.get_object()
        extra = 0 if TenantDocument.objects.filter(tenant=instance).exists() else 1
        TenantDocumentFormset = inlineformset_factory(
            Tenant,
            TenantDocument,
            can_delete=True,
            extra=extra,
            form=TenantDocumentForm,
        )
        return TenantDocumentFormset

    def post(self, *args, **kwargs):
        self.object = self.get_object()
        form = TenantForm(self.request.POST, instance=self.object)
        TenantDocumentFormset = self.get_formset()
        tenant_document_formset = TenantDocumentFormset(self.request.POST, self.request.FILES, instance=self.object, prefix='tenant_document_formset', form_kwargs={'empty_permitted': False})
        if form.is_valid() and tenant_document_formset.is_valid():
            data = form.save(commit=False)
            data.updater = self.request.user
            data.date_updated = timezone.now()
            data.save()
            form.save_m2m()

            for item in tenant_document_formset:
                if item not in tenant_document_formset.deleted_forms:
                    d_data = item.save(commit=False)
                    d_data.save()

            for f in tenant_document_formset.deleted_forms:
                f.instance.delete()

            response_data = {
                "status": "true",
                "title": "Successfully Updated",
                "message": "Tenant Successfully Updated.",
                "redirect": "true",
                "redirect_url": reverse('tenants:tenant_list')
            }
        else:
            message = generate_form_errors(form, formset=False)
            response_data = {
                "status": "false",
                "stable": "true",
                "title": "Form validation error",
                "message": message
            }

        return HttpResponse(json.dumps(response_data), content_type='application/javascript')

    def get(self, *args, **kwargs):
        self.object = self.get_object()
        form = TenantForm(instance=self.object)
        TenantDocumentFormset = self.get_formset()
        tenant_document_formset = TenantDocumentFormset(instance=self.object, prefix="tenant_document_formset")
        context = {
            "form": form,
            "title": "Edit Tenant : " + self.object.__str__(),

templates/tenants/tenant/tenant_list.html
{% extends "base.html" %}
{% load static %}
{% load i18n %}
{% block content %}




<div class="row">
    <div class="col-12">
        <div class="card">
            <div class="card-header">
                <div class="row align-items-center">
                    <div class="col" style="flex-grow:2">
                        <h4 class="card-title">{{title}}</h4>
                    </div>
                    <!--end col-->
                    <div class="col-auto" style="flex-grow:1">
                        <form action=".">
                            <div class="row">
                                <div class="col-md-9">
                                                                                <input class="form-control" placeholder="Search" value="{{request.GET.q|default:''}}" name="q" type="search">

                                    </div>
                                    <div class="col-md-3"><button class="btn  btn-soft-primary" role="button">Submit</button></div>
                                </div>
                            </div>
                        </form>
                    <!--end col-->
                </div>
                <!--end row-->
            </div>
            <!--end card-header-->
            <div class="card-body">
                <div class="table-responsive">

                    {% if instances %}
                    <table class="table mb-0">
                        <thead class="thead-light">
                            <tr>
                                <th>Sl.no</th>
                                <th>Name</th>
                                <th>Address</th>
                                <th>Phone</th>
                                <th>Email</th>
                                <th>Creator</th>
                                <th>Updater</th>
                                <th class="text-right">Action</th>
                            </tr>
                        </thead>
                        <tbody>
                            {% for instance in instances %}
                            <tr>
                                <td>{% if page_obj.has_other_pages %}{{ forloop.counter0|add:page_obj.start_index }}{% else %}{{forloop.counter}}{% endif %}</td>
                                <td>{{instance.name}}</td>
                                <td>{{instance.address}}</td>
                                <td>{{instance.phone}}</td>
                                <td>{{instance.email}}</td>
                                <td>{{instance.creator}} ({{instance.date_added|date:datetime_format}})</td>
                                <td>{{instance.updater|default:"-"}} {% if instance.date_updated %}({{instance.date_updated|date:datetime_format}}){% endif %}</td>
                                <td class="text-right">
                                    <a href="{% url 'tenants:tenant_view' instance.pk %}"><i class="las la-eye text-info font-18" title="View"></i></a>
                                    <a href="{% url 'tenants:tenant_update' instance.pk %}"><i class="las la-pen text-warning font-18" title="Edit"></i></a>
                                    <a href="{% url 'tenants:tenant_delete' instance.pk %}" data-id="{{instance.pk}}" data-text="Are you sure you want to delete this item?" data-title="Are you sure?" class="action-button remove"><i class="las la-trash-alt text-danger font-18" title="Delete"></i></a>
                                </td>
                            </tr>
                            {% endfor %}
                        </tbody>
                    </table>
                    {% include 'includes/pagination.html' %}
                    {% else %}
                    {% include 'includes/not_found.html' %}
                    {% endif %}

                </div>
                <!--end table-responsive-->
            </div>
            <!--end card-body-->
        </div>
        <!--end card-->
    </div>
    <!--end col-->
</div>
{% endblock %}
{% block static %}
{% endblock %}

templates/tenants/tenant/tenant_view.html
{% extends "base.html" %}
{% load static %}
{% load i18n %}
{% block content %}


<div class="row">
    <div class="col-lg-12">
        <div class="card">
            <div class="card-header d-flex justify-content-between">
                <h4 class="card-title">Details</h4>

                <div class="button-items text-right">
                    <a href="{% url 'tenants:tenant_update' instance.pk %}" class="btn btn-warning btn-icon-square-sm"><i class="fas fa-pen"></i></a>
                    <a href="{% url 'tenants:tenant_delete' instance.pk %}" data-id="{{ instance.pk }}" data-text="Are you sure you want to delete this Item?" data-title="Are you sure?" class="btn btn-danger btn-icon-square-sm action-button remove redirect"><i class="fas fa-trash-alt" title="Delete"></i></a>
                </div>
            </div>
            <div class="card-body">
                <div class="row">
                    <div class="list-group lg-alt c-overflow col-md-4 mb-2">
                        <div class="list-group-item media">
                            <div class="media-body">
                                <div class="lgi-heading">Name</div><small class="lgi-text"> {{instance.name}}</small>
                            </div>
                        </div>
                    </div>
                    <div class="list-group lg-alt c-overflow col-md-4 mb-2">
                        <div class="list-group-item media">
                            <div class="media-body">
                                <div class="lgi-heading">Address</div><small class="lgi-text"> {{instance.address}}</small>
                            </div>
                        </div>
                    </div>
                    <div class="list-group lg-alt c-overflow col-md-4 mb-2">
                        <div class="list-group-item media">
                            <div class="media-body">
                                <div class="lgi-heading">Location</div><small class="lgi-text"> {{instance.location}}</small>
                            </div>
                        </div>
                    </div>

                    <div class="list-group lg-alt c-overflow col-md-4 mb-2">
                        <div class="list-group-item media">
                            <div class="media-body">
                                <div class="lgi-heading">Creator</div><small class="lgi-text"> {{instance.creator}} ({{instance.date_added|date:datetime_format}})</small>
                            </div>
                        </div>
                    </div>

                    <div class="list-group lg-alt c-overflow col-md-4 mb-2">
                        <div class="list-group-item media">
                            <div class="media-body">
                                <div class="lgi-heading">Updater</div><small class="lgi-text"> {{instance.updater|default:"-"}} {% if instance.date_updated %}({{instance.date_updated|date:datetime_format}}){% endif %}</small>
                            </div>
                        </div>
                    </div>


                </div>



            </div>
            <div class="col-lg-12">
                <div class="card">
                    <div class="card-header d-flex justify-content-between">
                        <h4 class="card-title">Documents</h4>
                    </div>
                    <div class="card-body">
                        <div class="row">
                            <table class="table table-tranx">
                                <thead>
                                    <tr>
                                        <th>Type</th>
                                        <th>File</th>

                                    </tr>
                                </thead>
                                <tbody>
                                    {% for tenant_document in instance.tenantdocument_set.all %}
                                    <tr class="form_set_row">
                                        <td>{{tenant_document.document_type}}</td>
                                        <td>
                                            <a target="_blank" href="{{tenant_document.file.url}}">View</a>
                                            <a href="{{tenant_document.file.url}}"><i class="fas fa-download"></i></a>
                                        </td>
                                    </tr>
                                    {% endfor %}
                                </tbody>
                            </table>
                        </div>
                    </div>
                </div>
            </div>
            <div class="col-lg-12">
                <div class="card">
                    <div class="card-header d-flex justify-content-between">
                        <h4 class="card-title">Units</h4>
                    </div>
                    <div class="card-body">
                        <div class="row">
                            <table class="table table-tranx">
                                <thead>
                                    <tr>
                                        <th>Name</th>
                                        <th>Agreement end date</th>
                                        <th>Upcoming rent date</th>
                                        <th>Agreement</th>
                                        <th>Active</th>
                                        <th>Rent</th>
                                    </tr>
                                </thead>
                                <tbody>
                                    {% for item in instance.tenantunitassign_set.all %}
                                    <tr class="form_set_row">

                                        <td>{{item.unit}}</td>
                                        <td>{{item.agreement_end_date}}</td>
                                        <td>{{item.upcoming_rent_date}}</td>
                                        <td>{{item.agreement}}</td>
                                        <td>{{item.is_active|yesno:"&#x2705;,&#10060;"|safe}}</td>
                                        <td>{{item.unit.rent}}</td>
                                        <td>
                                            {% if item.agreement %}
                                            <a target="_blank" href="{{item.agreement.url}}">View</a>
                                            <a href="{{item.agreement.url}}"><i class="fas fa-download"></i></a>
                                            {% endif %}
                                        </td>

                                    </tr>
                                    {% endfor %}
                                </tbody>
                            </table>
                        </div>
                    </div>
                </div>
            </div>

        </div>
    </div>
    <!--end col-->
</div>

{% endblock %}
{% block static %}
{% endblock %}